using Newtonsoft.Json;
using System.Collections.Generic;

namespace TeachR.WebCommunication
{
    /// <summary>
    /// Wraps around JSON data from RTC messages.
    /// </summary>
    public class JsonMsg
    {
        /// <summary>
        /// Raw content of the message
        /// </summary>
        public string content;

        /// <summary>
        /// Retrieve value from the message.
        /// </summary>
        /// <typeparam name="T">Type of the value to try and retrieve.</typeparam>
        /// <returns>Value of the message</returns>
        public T GetValue<T>()
        {
            return JsonConvert.DeserializeObject<T>(content);
        }

        /// <summary>
        /// Deserialize the content directly into a dictionary.
        /// </summary>
        /// <typeparam name="T">type of the dictionary values</typeparam>
        /// <returns>dictionary</returns>
        public Dictionary<string, T> ToDict<T>()
        {
            return JsonConvert.DeserializeObject<Dictionary<string, T>>(content);
        }
    }
}