using System;
using TeachR.ApplicationManager;
using UnityEngine;

namespace TeachR.WebCommunication
{
    
    public class WebsocketDelegateHooks : MonoBehaviour
    {
        /// <summary>
        /// Action event that can be used to use the update functionality in non-monobehavior scripts.
        /// </summary>
        public static event Action OnUpdate;


        /// <summary>
        /// Action event that can be used to use the fixedUpdate functionality in non-monobehavior scripts.
        /// </summary>
        public static event Action OnFixedUpdate;

        /// <summary>
        /// Action event that can be used to use the lateUpdate functionality in non-monobehavior scripts.
        /// </summary>
        public static event Action OnLateUpdate;

        [Obsolete] //Socketserver is deprecated
        private void Awake()
        {
            DontDestroyOnLoad(gameObject);
            InitGlobals.WebsocketInitHook += CoachRtc.Init;
        }

        // Update is called once per frame
        void Update()
        {
            OnUpdate?.Invoke();
        }

        private void LateUpdate()
        {
            OnLateUpdate?.Invoke();
        }

        private void FixedUpdate()
        {
            OnFixedUpdate?.Invoke();
        }
    }
}
